C
C      WRITE (6,*) ' READING OF GENERAL DATA: Starting...'
      OPEN  (1, FILE=FILEGD, STATUS='OLD')
C
      IF (IFINDKEY (1, 'TITLE') .NE. 0) THEN
         READ  (1,'(A80)') TITLE
      ELSE
         TITLE = 'Untitled gpfep problem'
      END IF
      WRITE (6,'(A80)') TITLE
C
      IF (IFINDKEY (1, 'ELEMENTS') .NE. 0) THEN
         READ (1, *) NEL
      ELSE
         NEL = 0
      END IF
C      WRITE (6,*) '  NEL = ',NEL
C
      IF (IFINDKEY (1, 'ELEMENTS_IN_SURFACE_MESH') .NE. 0) THEN
         READ (1, *) NELSUR
      ELSE
         NELSUR = 0
      END IF
C
      IF (IFINDKEY (1, 'SPACE_DIMENSIONS') .NE. 0) THEN
         READ (1, *) NDIM
      ELSE
         STOP 'SPACE_DIMENSIONS not found'
      END IF
C
      if (ndim .lt. 1 .or. ndim .gt. 3)
     *   stop 'unrecognizable space dimensions (use: 0 < ndim < 4)'
C
      IF (IFINDKEY (1, 'SYMMETRY_INDICATOR') .NE. 0) THEN
         READ (1, *) JSIM
      ELSE
         JSIM = 0
      END IF
      IF (NDIM.EQ.3.AND.JSIM.NE.0) STOP 'WRONG SYMMETRY INDICATOR'
C
      IF (IFINDKEY (1,
     *     'DEGREE_OF_POLYNOMIAL_INTEGRATED_EXACTLY') .NE. 0) THEN
         READ (1, *) ITGDEG
      ELSE
         ITGDEG = 2
      END IF
C
      IF (IFINDKEY (1, 'INTEGRATION_RULE') .NE. 0) THEN
         READ (1, *) ITGTYP
      ELSE
         ITGTYP = 1
      END IF
C
      IF (IFINDKEY (1, 'NUMBER_OF_UNKNOWN_FIELDS') .NE. 0) THEN
         READ (1, *) NFIELD
      ELSE
         NFIELD = 1
      END IF
      WRITE (6, *) '  ',NFIELD, ' unknown fields'
C
      IF (NFIELD .GT. MAX_NUMB_FIELDS) STOP 'EXCESSIVE NUMBER OF FIELDS'
C
      IF (IFINDKEY (1,
     *     'INTERPOLATION_AND_COMPONENTS_OF_EACH_FIELD') .NE. 0) THEN
         DO IFIELD = 1,NFIELD
            READ (1,*) KSHAP(IFIELD),KCOMP(IFIELD)
         END DO
      ELSE
         STOP 'INTERPOLATION_AND_COMPONENTS_OF_EACH_FIELD not found'
      END IF
C
      IF (IFINDKEY (1, 'NUMBER_OF_MESHES_TO_READ') .NE. 0) THEN
         READ (1, *) NMESH
      ELSE
         NMESH = 1
      END IF
      IF (NMESH .GT. MAX_NUMB_MESHES) STOP 'EXCESSIVE NUMBER OF MESHES'
C
      IF (IFINDKEY (1, 'FILES_CONTAINING_MESHES') .NE. 0) THEN
         DO IMESH=1,NMESH
            READ (1,'(A80)') FILEMS(IMESH)
         END DO
      ELSE
         STOP 'FILES_CONTAINING_MESHES not found'
      END IF
C
      IF (IFINDKEY (1,'FILES_CONTAINING_SURFACE_MESHES') .NE. 0) THEN
         DO IMESH=1,NMESH
            READ (1,'(A80)') FILEMSSUR(IMESH)
         END DO
         iswsur = 1
      ELSE
         iswsur = 0
C         STOP 'FILES_CONTAINING_SURFACE_MESHES not found'
      END IF
C
      IF (IFINDKEY (1,
     *  'ELEMENT_TYPE_AND_NODES_PER_ELEMENT_FOR_EACH_MESH') .NE. 0) THEN
         DO IMESH = 1,NMESH
            READ (1, *) IELTYP(IMESH),NNODE(IMESH)
         END DO
      ELSE
         IF (NMESH .NE. 1) STOP
     *    'ELEMENT_TYPE_AND_NODES_PER_ELEMENT_FOR_EACH_MESH not found'
         WRITE (6, *) 'LINEAR ELEMENTS'
         IF (NDIM .EQ. 1) THEN
            IELTYP(1) = 1
            NNODE(1) = 2
         ELSE IF (NDIM .EQ. 2) THEN
            IELTYP(1) = 3
            NNODE(1) = 3
         ELSE IF (NDIM .EQ. 3) THEN
            IELTYP(1) = 5
            NNODE(1) = 4
         END IF
      END IF
C
      IF (IFINDKEY (1,'INTERPOLATION_CODE_FOR_EACH_MESH') .NE. 0) THEN
         DO IMESH = 1,NMESH
            READ (1,*) MESINT(IMESH)
         END DO
      ELSE
         IF (NMESH .NE. 1) 
     *        STOP 'INTERPOLATION_CODE_FOR_EACH_MESH not found'
         WRITE (6, *) 'LINEAR INTERPOLATION'
         IF (NDIM .EQ. 1) THEN
            MESINT(1) = 10
         ELSE IF (NDIM .EQ. 2) THEN
            MESINT(1) = 30
         ELSE IF (NDIM .EQ. 3) THEN
            MESINT(1) = 50
         END IF
      END IF
      ITPGEO = MESINT(1)
C
      IF (IFINDKEY (1,'MESH_CORRESPONDING_TO_EACH_FIELD') .NE. 0) THEN
         DO IFIELD = 1,NFIELD
            READ (1,*) KFTYP(IFIELD)
         END DO
      ELSE
         IF (NMESH .NE. 1)
     *        STOP 'MESH_CORRESPONDING_TO_EACH_FIELD not found'
         DO IFIELD = 1,NFIELD
            KFTYP(IFIELD) = 1
         END DO
      END IF
C THE PERMUTATION VECTORS PROVIDE THE RENUMBERING OF UNKNOWNS
      IF (IFINDKEY (1,'PERMUTATION_VECTORS_FILE') .NE. 0) THEN
         READ (1, '(A80)') FILPER
      ELSE
         FILPER=' NONE'
      END IF
C
      IF (IFINDKEY (1,'INITIAL-GUESS_FILE') .NE. 0) THEN
         READ (1, '(A80)') FILEGS
         WRITE (6,*) ' INITIAL CONDITION FROM FILE: ', FILEGS
      ELSE
         FILEGS=' NONE'
      END IF
C
      IF (IFINDKEY (1,'FILE_WITH_DATA_TO_CONSTRUCT_B.C.') .NE. 0) THEN
         READ (1, '(A80)') FILBCC
      ELSE
         FILBCC='bcc.dat'
      END IF
C
      IF (IFINDKEY (1,'BOUNDARY-CONDITIONS_FILE') .NE. 0) THEN
         READ (1, '(A80)') FILEBC
      ELSE
         FILEBC='gp.bco'
      END IF
C
      IF (IFINDKEY (1,'OBLIQUE_NODES_SWITCH') .NE. 0) THEN
         READ (1, *) ISWNOB
      ELSE
         ISWNOB = 0
      END IF
C
      IF (IFINDKEY (1,'NUMBER_OF_OBLIQUE_NODES') .NE. 0) THEN
         READ (1, *) (NUMNOB(IMESH),IMESH=1,NMESH)
      ELSE
         if (iswnob.ne.0) STOP 'NUMBER_OF_OBLIQUE_NODES REQUIRED'
      END IF
C
      IF (IFINDKEY (1,'PERIODIC_NODES_SWITCH') .NE. 0) THEN
         READ (1, *) ISWPERIO
      ELSE
         ISWPERIO = 0
      END IF
C
      IF (IFINDKEY (1,'STATISTICS_FILE') .NE. 0) THEN
         READ (1, '(A80)') FILEST
      ELSE
         FILEST='NONE'
      END IF
C
C      CALL RECHKY (1,' RESTART FILE:',FILREE)
      IF (IFINDKEY (1,'RESTART_FILE') .NE. 0) THEN
         READ (1, '(A80)') FILREE
      ELSE
         FILREE='gp.res'
      END IF
C
C      CALL REREKY (1,' INITIAL VALUE OF CONTINUATION PARAMETER:',PARCI)
      IF (IFINDKEY (1,'INITIAL_CONTINUATION_PARAMETER') .NE. 0) THEN
         READ (1, *) PARCI
      ELSE
         PARCI = 0.D0
      END IF
C
C      CALL REREKY (1,' FINAL VALUE OF CONTINUATION PARAMETER:',PARCF)
      IF (IFINDKEY (1,'FINAL_CONTINUATION_PARAMETER') .NE. 0) THEN
         READ (1, *) PARCF
      ELSE
         WRITE (6,*) '  Warning: No final continuation parameter given'
         PARCF = 9999999.
      END IF
C
C      CALL REINKY (1,' NUMBER OF CONTINUATION STEPS:',NCONT)
      IF (IFINDKEY (1,'NUMBER_OF_CONTINUATION_STEPS') .NE. 0) THEN
         READ (1, *) NCONT
      ELSE
         NCONT = 0
      END IF
C
C      CALL REINKY (1,' MAXIMUM NUMBER OF NONLINEAR ITERATIONS:',NITMAX)
      IF (IFINDKEY (1,'MAXIMUM_NONLINEAR_ITERATIONS') .NE. 0) THEN
         READ (1, *) NITMAX
      ELSE
         NITMAX = 6
      END IF
C
C      CALL REREKY (1,' CONVERGENCE TOLERANCE FOR ITERATIONS:',TOLNLI)
      IF (IFINDKEY (1,'TOLERANCE_NONLINEAR') .NE. 0) THEN
         READ (1, *) TOLNLI
      ELSE
         TOLNLI = 1.0D-06
      END IF
C
C      CALL REINKY (1,' SWITCH FOR NONLINEAR SOLVER:',ISWNLI)
      IF (IFINDKEY (1,'SWITCH_FOR_NONLINEAR_SOLVER') .NE. 0) THEN
         READ (1, *) ISWNLI
      ELSE
         ISWNLI = 0
      END IF
C
C      CALL REINKY(1,' MAXIMUM NUMBER OF LINE-SEARCH ITERATIONS:',NITLS)
      IF (IFINDKEY (1,'MAXIMUM_LINE-SEARCH_ITERATIONS') .NE. 0) THEN
         READ (1, *) NITLS
      ELSE
         NITLS = 1
      END IF
C
C      CALL REREKY (1,' PARAMETER FOR LINE-SEARCH:',PARLS)
      IF (IFINDKEY (1,'LINE-SEARCH_PARAMETER') .NE. 0) THEN
         READ (1, *) PARLS
      ELSE
         PARLS = 0.8
      END IF
C
C      CALL RECHKY (1,' LINEAR SYSTEM SOLVER:',SOLVER)
      IF (IFINDKEY (1,'LINEAR_SYSTEM_SOLVER') .NE. 0) THEN
         READ (1, '(A80)') SOLVER
      ELSE
         SOLVER = 'DIRECT'
      END IF
C
      IF (SOLVER(1:6).EQ.'ITERNS') THEN
         WRITE (6,*) 'CGS SOLVER'
         PARNUM(30)=-1.D0
      END IF
C      CALL REINKY (1,' MAXIMUM ITERATIONS FOR LINEAR SOLVER:',NSOLV)
      IF (IFINDKEY (1,'MAXIMUM_LINEAR_ITERATIONS') .NE. 0) THEN
         READ (1, *) NSOLV
      ELSE
         NSOLV = 500
      END IF
C
C      CALL REREKY (1,' TOLERANCE FOR LINEAR SOLVER:',TOLSOL)
      IF (IFINDKEY (1,'TOLERANCE_LINEAR') .NE. 0) THEN
         READ (1, *) TOLSOL
      ELSE
         TOLSOL = 1.0D-07
      END IF
C
C      CALL REINKY 
C     *     (1,' NUMBER OF MATERIAL PARAMETERS (LIST BELOW):',NPARM)
      IF (IFINDKEY (1,'MATERIAL_PARAMETERS') .NE. 0) THEN
         READ (1, *) NPARM
      ELSE
         NPARM = 0
      END IF
C
      DO I=1,NPARM
         READ (1,*) PARMAT(I)
      END DO
C      CALL REINKY 
C     *     (1,' NUMBER OF NUMERICAL PARAMETERS (LIST BELOW):',NPARN)
      IF (IFINDKEY (1,'NUMERICAL_PARAMETERS') .NE. 0) THEN
         READ (1, *) NPARN
      ELSE
         NPARN = 0
      END IF
C
      DO I=1,NPARN
         READ (1,*) PARNUM(I)
      END DO
C      CALL REINKY (1,' FIRST CONTINUATION STEP WITH OUTPUT:',KOUTI)
      IF (IFINDKEY (1,'FIRST_OUTPUT') .NE. 0) THEN
         READ (1, *) KOUTI
      ELSE
         KOUTI = 1
      END IF
C
C      CALL REINKY (1,' NUMBER OF STEPS BETWEEN OUTPUTS:',KOUTD)
      IF (IFINDKEY (1,'STEPS_BETWEEN_OUTPUTS') .NE. 0) THEN
         READ (1, *) KOUTD
      ELSE
         KOUTD = 1
      END IF
C
C      CALL REAKEY (1,' RESULTS FILE FOR EACH FIELD (LIST BELOW):')
      IF (IFINDKEY (1,'RESULTS_FILES') .NE. 0) THEN
         DO IFIELD=1,NFIELD
            READ (1,'(A80)') FILOUT(IFIELD)
         END DO
      ELSE
         DO IFIELD=1,NFIELD
            FILOUT(IFIELD)= ' NONE'
         END DO
      END IF
C
C      CALL RECHKY (1,' POST-PROCESSOR:',POSTPR)
      IF (IFINDKEY (1,'POST-PROCESSOR') .NE. 0) THEN
         READ (1, '(A80)') POSTPR
      ELSE
         POSTPR = ' CRUDE'
      END IF
C      CALL REAKEY (1,' POST-PROCESSED RESULTS FILES (LIST BELOW):')
      IF (IFINDKEY (1,'POST-PROCESSED_FILES') .NE. 0) THEN
         DO IFIELD=1,NFIELD
            READ (1,'(A80)') FILPOS(IFIELD)
         END DO
      ELSE
         DO IFIELD=1,NFIELD
            FILPOS(IFIELD)= ' NONE'
         END DO
      END IF
      CLOSE (1)
C      WRITE (6,*) ' READING OF GENERAL DATA: ...Complete.'
